#include <stdio.h> 
#include <string.h> 
#include <stdlib.h> 


#define MAXLINES 5000  /* max #lines to be sorted */ 

char *lineptr[MAXLINES]; /*pointers to text lines */ 
int readlines(char *lineptr[ ], int nlines); 

void writelines(char *lineptr[], int nlines); 


void qsort_(char *lineptr[], int left, int right); 

/* sort input lines */ 
main(){
  int nlines; /* number of lines read */ 
  
  printf("Please input a few lines and ended with a line starting with a ;\n"); 
  if((nlines = readlines(lineptr, MAXLINES)) >= 0) {
    qsort_(lineptr, 0, nlines - 1); 
    writelines(lineptr, nlines); 
    return 0; 
  }
  else {
    printf("error: input too big to sort \n"); 
    return 1; 
  }
}


#define MAXLEN 1000 /* max length of any input line */ 
int getline_(char *, int); 
char *alloc(int); 

/* readlines: read input lines */ 
int readlines(char *lineptr[], int maxlines) {
  int len, nlines; 
  char *p, line[MAXLEN]; 
  
  nlines = 0; 
  while ((len = getline_(line, MAXLEN)) > 0) 
    if ( nlines >= maxlines || (p = malloc (len)) == NULL ) 
      return -1; 
    else {
      line[len - 1] = '\0'; 
      strcpy (p, line); 
      lineptr[nlines++] = p; 
    }
  return nlines; 
}


/* writelines: write output lines */ 

void writelines(char *lineptr[], int nlines) {
  int i; 
  for (i = 0; i < nlines; i ++) 
    printf("%s\n", lineptr[i]); 
}


